/**********************************************************************
  u[N|Cg̐ݒ
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int	bp_cmd( struct TOKEN_STRUCT *tk_pt , int mode )
{
int i,j ;
int id ; 
  
  if( tk_pt->pt[1]==NULL ){
    for( i=0 ; i<MAX_PROCESS_ID ; i++ ){
      if( proc_list.proc[i].bp_num>0 ){
	fprintf(simmsgfp,"--- Break Point(s) for Process ID = %2d --\n",i) ;
	for( j=0 ; j<proc_list.proc[i].bp_num ; j++ ){
	  fprintf(simmsgfp,"No.%02d : 0x%08x\n",j,proc_list.proc[i].break_pt[j]) ;
	}
      }
    }
    return(NORMAL_EXIT) ;
  }
  if( tk_pt->pt[2]==NULL ){
    id=proc_list.cur_id ;
  }else{
    if( tk_pt->pt[2][0]=='+' ){
      id=proc_list.cur_id+1 ;
    }else{
      if( tk_pt->pt[2][0]=='-' ){
	id=proc_list.cur_id-1 ;
      }else{
	id=exatoi(tk_pt->pt[2]) ;
      }
    }
    if( id>=MAX_PROCESS_ID || id<0 ){
      fprintf(simmsgfp,"Invalid Process ID (Min=0,Max=%d specify=%d).\n",
	      (MAX_PROCESS_ID)-1,id) ;
      return(NORMAL_EXIT) ;
    }
  }
  if( proc_list.proc[id].bp_num==MAX_BREAK_POINT_NUM ){
    fprintf(simmsgfp,"Break Point Buffer is full.\n") ;
    return(NORMAL_EXIT) ;
  }

  proc_list.proc[id].break_pt[proc_list.proc[id].bp_num] = exatoi(tk_pt->pt[1]) ;
  fprintf(simmsgfp,"Setting bp=0x%08x , ID=%d\n",
	  proc_list.proc[id].break_pt[proc_list.proc[id].bp_num], id) ;
  proc_list.proc[id].bp_num++ ;
  return(NORMAL_EXIT) ;

}
