/***
  ANZX}N(œK̓RpCɂ΂Ă炤)
  d s*b,u*̎GPRAf*b,d*b̎FPR 鎖B
***/

#ifdef SUPPORT_MMU_ADRS_TRANSRATION
int	adtr_func( struct MACHINE_RESOURCE *mres , int *pa, unsigned int ea ) ;
#else
#define adtr_func(m,p,l)  {*(p)=l ;}
#endif

#define seg(a)  (((a) & 0xf0000000)>>28)
#define lad(a)  ((a) & 0x0fffffff)


#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
#define	fetchs2b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+0];\
                         if( (uc[1]&0x80)!=0 ){\
                           uc[2]=0xff;uc[3]=0xff;\
                         }}
#define	fetchu1b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+0];\
                         }
#define	fetchu2b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+1];\
	                 uc[1]=mres->mem[seg(ad)][lad(ad)+0];\
                         }
#define	fetchu4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+3];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+0];\
                         }
#define	fetchf4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         float f ;\
                         uc=(unsigned char *)&f;\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+3];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+0];\
                         d=f;}
#define	fetchd8b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         d=0;uc=(unsigned char*)&d;\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         uc[0]=mres->mem[seg(ad)][lad(ad)+7];\
                         uc[1]=mres->mem[seg(ad)][lad(ad)+6];\
                         uc[2]=mres->mem[seg(ad)][lad(ad)+5];\
                         uc[3]=mres->mem[seg(ad)][lad(ad)+4];\
                         uc[4]=mres->mem[seg(ad)][lad(ad)+3];\
                         uc[5]=mres->mem[seg(ad)][lad(ad)+2];\
                         uc[6]=mres->mem[seg(ad)][lad(ad)+1];\
                         uc[7]=mres->mem[seg(ad)][lad(ad)+0];\
                         }

#define	storeu1b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         uc=(unsigned char*)&d;\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[0];\
			 }
#define	storeu2b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         uc=(unsigned char*)&d;\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[0];\
			 }
#define	storeu4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         uc=(unsigned char*)&d;\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[3];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+2]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+3]=uc[0];\
			 }
#define	storef4b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         float f;\
                         f=d;uc=(unsigned char *)&f;\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[3];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+2]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+3]=uc[0];\
			 }
#define	stored8b(d,a)	{unsigned char *uc;\
                         int ad;\
                         int res;\
                         uc=(unsigned char*)&d;\
                         if( (res=adtr_func(mres,&ad,(a)))!=NORMAL_EXIT ) return(res) ;\
                         if( lad(ad)>=mres->mem_size[seg(ad)] ) return(MEM_AREA_OVER);\
                         mres->mem[seg(ad)][lad(ad)+0]=uc[7];\
                         mres->mem[seg(ad)][lad(ad)+1]=uc[6];\
                         mres->mem[seg(ad)][lad(ad)+2]=uc[5];\
                         mres->mem[seg(ad)][lad(ad)+3]=uc[4];\
                         mres->mem[seg(ad)][lad(ad)+4]=uc[3];\
                         mres->mem[seg(ad)][lad(ad)+5]=uc[2];\
                         mres->mem[seg(ad)][lad(ad)+6]=uc[1];\
                         mres->mem[seg(ad)][lad(ad)+7]=uc[0];\
			 }
#else
#define	fetchs2b(d,a)	{short *sh;\
                         sh=&mres->mem[(a)];\
                         (d)=*sh;}
#define	fetchu1b(d,a)	{(d)=mres->mem[(a)];}
#define	fetchu2b(d,a)	{unsigned short *us;\
                         us=&mres->mem[(a)];\
                         (d)=*us;}
#define	fetchu4b(d,a)	{unsigned int *ui;\
                         ui=&mres->mem[(a)] ;\
                         (d)=*ui;}
#define	fetchf4b(d,a)	{float *fl;\
                         fl=&mres->mem[(a)] ;\
                         (d)=*fl;}
#define	fetchd8b(d,a)	{double *db;\
                         db=&mres->mem[(a)] ;\
                         (d)=*db;}
#define	storeu1b(d,a)	{(d)=mres->mem[(a)  ];}
#define	storeu2b(d,a)	{unsigned short *us;\
                         us=&mres->mem[(a)];\
                         *us=d;}
#define	storeu4b(d,a)	{unsigned int *ui;\
                         ui=&mres->mem[(a)] ;\
                         *ui=(d);}
#define	storef4b(d,a)	{float *fl;\
                         fl=&mres->mem[(a)] ;\
                         *fl=(d);}
#define	stored8b(d,a)	{double *db;\
                         db=&mres->mem[(a)] ;\
                         *db=(d);}
#endif /**LITTLE_ENDIAN**/

int	memory_copy( struct MACHINE_RESOURCE *, int, int, int ) ;

